# API

**Get All Users**

`GET /users`

return list of users based on popularity (post counts + follower counts + mentioned counts) and metadata

```
curl https://api.auti.sm/v1/users?limit=1
```

```
{
    "payload":
    [
        {
            "ens": null,
            "username": "0x267eF95Cf7F536b3D7cddCDE53DedeF913C4D01D",
            "address": "0x267eF95Cf7F536b3D7cddCDE53DedeF913C4D01D",
            "joinedTx": "0xa8f2fadc8a77b63bbaac0c39aa1b0eb7f7013d60e60ed9300231af832e0281d1",
            "type": "arbitrum",
            "pubkey": "kJ--taveSOeLzItmBlgjwDU6X3SAll-FvklAqNFpcsw.FOGWEDKU2l8aeuVHbEFzFanZ_MMKC2qG4jhW5cHmHMU",
            "joinedAt": 1634475478000,
            "name": "GL10",
            "bio": "",
            "profileImage": "",
            "coverImage": "",
            "twitterVerification": "",
            "website": "",
            "meta":
            {
                "blockedCount": 0,
                "blockingCount": 0,
                "followerCount": 0,
                "followingCount": 2,
                "postingCount": 0,
                "mentionedCount": 0,
                "followed": null,
                "blocked": null
            }
        }
    ]
}
```

**Search User By String**

`GET /users/search/:query`

return list of users whose names beings with `query`

```
curl https://api.auti.sm/v1/users/search/yagami
```

```
{
    "payload":
    [
        {
            "ens": "yagamilight.eth",
            "username": "0xd44a82dD160217d46D754a03C8f841edF06EBE3c",
            "address": "0xd44a82dD160217d46D754a03C8f841edF06EBE3c",
            "joinedTx": "0xe15236b90597375392ed394a442a96aff65a18a5a9146c9ccc6da0619c81d6cd",
            "type": "arbitrum",
            "pubkey": "dBgXJATrP4KeE6zfuR4_arauMIeT_86MrQg6JbbnuxM.yJXykCW6qjB54B29by8vIWoMwk8T5NG_3awHdKC9Bgc",
            "joinedAt": 1634154376000,
            "name": "Yagami",
            "bio": "",
            "profileImage": "https://upload.wikimedia.org/wikipedia/zh/0/0c/Light_from_Death_Note.jpg",
            "coverImage": "https://images-na.ssl-images-amazon.com/images/S/sgp-catalog-images/region_GB/uomlg-JWM4ZMJATR3-Full-Image_GalleryBackground-en-US-1572961461852._SX1080_.jpg",
            "twitterVerification": "",
            "website": "",
            "meta":
            {
                "blockedCount": 0,
                "blockingCount": 0,
                "followerCount": 6,
                "followingCount": 2,
                "postingCount": 3,
                "mentionedCount": 0,
                "followed": null,
                "blocked": null
            }
        }
    ]
}
```

**Get User by ENS or Address**

`GET /users/:ensOraddress`

return a user whose address matches `ensOraddress`

```
curl https://api.auti.sm/v1/users/0xryuk.eth
```

```
{
    "payload":
    {
        "username": "0x3F425586D68616A113C29c303766DAD444167EE8",
        "address": "0x3F425586D68616A113C29c303766DAD444167EE8",
        "joinedTx": "0x106d8972b4e1e183953acc2e562a13e637e9a8139449242aae0b678a9fd5a5d8",
        "type": "arbitrum",
        "pubkey": "uVbA3TT8BS2x0WY8vpBQBtMd1aLTwFOkD6orwUVEyCQ.loloQZF5Ofcv3wExUHX97WMdRTYwidW46BnZCigf8_8",
        "joinedAt": 1634230636000,
        "name": "0xRyuk",
        "bio": "",
        "profileImage": "https://encrypted-tbn0.gstatic.com/images?q=tbn:ANd9GcTJc_VJeD57pmIPHJPiPboeYzTd6JZ3CvhY-A&usqp=CAU",
        "coverImage": "https://encrypted-tbn0.gstatic.com/images?q=tbn:ANd9GcSGOWvapxI_gG2fZMcaF0f2iY0KErLdwWW9Rg&usqp=CAU",
        "twitterVerification": "",
        "website": "",
        "meta":
        {
            "blockedCount": 0,
            "blockingCount": 0,
            "followerCount": 4,
            "followingCount": 3,
            "postingCount": 2,
            "mentionedCount": 3,
            "followed": null,
            "blocked": null
        },
        "ens": "0xryuk.eth"
    }
}
```

**Get All Posts**

`GET /posts`

return list of posts in descending chronological order

```
curl https://api.auti.sm/v1/posts?limit=1
```

```
{
    "payload":
    [
        {
            "type": "POST",
            "subtype": "M_POST",
            "messageId": "0x5d432ce201d2c03234e314d4703559102Ebf365C/900450baa9176d246c9199b680f6516d2c813088b4d94372d6a47a5133d1b94d",
            "hash": "900450baa9176d246c9199b680f6516d2c813088b4d94372d6a47a5133d1b94d",
            "createdAt": "1648001214812",
            "payload":
            {
                "topic": "https://twitter.com/AutismDev/status/1506452397199044608",
                "title": "",
                "content": "Few recent update to Auti.sm:\n- Add thread moderation setting for creator to moderate who can make a reply to their post\n- Add global visibility setting for creator to post to global feed or own feed only\n- Add setting ui\n- Default to blur all images",
                "reference": "",
                "attachment": ""
            },
            "meta":
            {
                "replyCount": 0,
                "likeCount": 3,
                "repostCount": 1,
                "liked": null,
                "reposted": null,
                "blocked": null,
                "interepProvider": null,
                "interepGroup": null,
                "rootId": "0x5d432ce201d2c03234e314d4703559102Ebf365C/900450baa9176d246c9199b680f6516d2c813088b4d94372d6a47a5133d1b94d",
                "moderation": "THREAD_HIDE_BLOCK",
                "modblockedctx": null,
                "modfollowedctx": null,
                "modmentionedctx": null,
                "modLikedPost": null,
                "modBlockedPost": null,
                "modBlockedUser": null,
                "modFollowerUser": null
            }
        }
    ]
}
```

**Get Post by Hash**

`GET /posts/:hash`

return a post with a specific `hash`

```
curl https://api.auti.sm/v1/post/58325b3eb288636fd2967f88651ce895a962a42d4b8f55fb1b8cce05b8a74a30
```

```
{
    "payload":
    {
        "type": "POST",
        "subtype": "",
        "messageId": "58325b3eb288636fd2967f88651ce895a962a42d4b8f55fb1b8cce05b8a74a30",
        "hash": "58325b3eb288636fd2967f88651ce895a962a42d4b8f55fb1b8cce05b8a74a30",
        "createdAt": "1647065053024",
        "payload":
        {
            "topic": "",
            "title": "",
            "content": "test",
            "reference": "",
            "attachment": ""
        },
        "meta":
        {
            "replyCount": 0,
            "likeCount": 0,
            "repostCount": 0,
            "liked": null,
            "reposted": null,
            "blocked": null,
            "interepProvider": "twitter",
            "interepGroup": "not_sufficient",
            "rootId": null,
            "moderation": null,
            "modblockedctx": null,
            "modfollowedctx": null,
            "modmentionedctx": null,
            "modLikedPost": null,
            "modBlockedPost": null,
            "modBlockedUser": null,
            "modFollowerUser": null
        }
    }
}
```

**Get All Replies**

`GET /replies?parents=:parents`

return list of replies of the `parent` post in ascending chronological order, filtered by the requester’s moderation policy

```
curl https://api.auti.sm/v1/replies?limit=20&offset=0&parent=0xc6Cb82D0199a30DC0Fc39127066CAE1815A8af55%2F5ff154c5155e47cb68d5e7ce5d7f94ba5c3a50a41a214bc1d560e7c61fd1f9fa
```

```
{
    "payload":
    [
        {
            "type": "POST",
            "subtype": "REPLY",
            "messageId": "0xd44a82dD160217d46D754a03C8f841edF06EBE3c/36674ef1f4b6a3c71456a06b36ba5c30d8d37a8b341563522a40a3866cb15c49",
            "hash": "36674ef1f4b6a3c71456a06b36ba5c30d8d37a8b341563522a40a3866cb15c49",
            "createdAt": "1639653936690",
            "payload":
            {
                "topic": "",
                "title": "",
                "content": "awesome! look forward to adding #rln functionality to #autism ",
                "reference": "0xc6Cb82D0199a30DC0Fc39127066CAE1815A8af55/5ff154c5155e47cb68d5e7ce5d7f94ba5c3a50a41a214bc1d560e7c61fd1f9fa",
                "attachment": ""
            },
            "meta":
            {
                "replyCount": 0,
                "likeCount": 0,
                "repostCount": 0,
                "liked": null,
                "reposted": null,
                "blocked": null,
                "interepProvider": null,
                "interepGroup": null,
                "rootId": null,
                "moderation": null,
                "modblockedctx": null,
                "modfollowedctx": null,
                "modmentionedctx": null,
                "modLikedPost": null,
                "modBlockedPost": null,
                "modBlockedUser": null,
                "modFollowerUser": null
            }
        }
    ]
}
```

**Get All Posts by Hashtag**

`GET /tags/:tagName`

return list of posts with the hashtag `tagName` in descending chronological order, filtered by the requester’s moderation policy

```
curl https://api.auti.sm/v1/tags/%23bugs?limit=1
```

```
{
    "payload":
    [
        {
            "type": "POST",
            "subtype": "",
            "messageId": "6c84375786fc63d708f45fea099a32c4c63b7b0f706e9b63e10128aa97f9d9f5",
            "hash": "6c84375786fc63d708f45fea099a32c4c63b7b0f706e9b63e10128aa97f9d9f5",
            "createdAt": "1647656557120",
            "payload":
            {
                "topic": "",
                "title": "",
                "content": "some #bugs\n- when replying to a moderated thread, the warning still shows up even if i can reply\n- need ability to remove users; some old anons accounts are no longer valid\n- need ways to show when anon posts has invalid proof\n- need gitdoc, man\n",
                "reference": "",
                "attachment": ""
            },
            "meta":
            {
                "replyCount": 3,
                "likeCount": 2,
                "repostCount": 0,
                "liked": "/4de30a7dabd3a1779b0ef0da9de906667d0cc066d15e80a95adcd460afd004cf",
                "reposted": null,
                "blocked": null,
                "interepProvider": "twitter",
                "interepGroup": "not_sufficient",
                "rootId": "6c84375786fc63d708f45fea099a32c4c63b7b0f706e9b63e10128aa97f9d9f5",
                "moderation": null,
                "modblockedctx": null,
                "modfollowedctx": null,
                "modmentionedctx": null,
                "modLikedPost": "/4de30a7dabd3a1779b0ef0da9de906667d0cc066d15e80a95adcd460afd004cf",
                "modBlockedPost": null,
                "modBlockedUser": null,
                "modFollowerUser": null
            }
        }
    ]
}
```

**Get All Hashtags based on Post Counts**

`GET /tags`

return list of existing hashtags in descending order based on total post counts

```
curl https://api.auti.sm/v1/tags?limit=3
```

```
{
    "payload":
    [
        {
            "tagName": "#bugs",
            "postCount": 4
        },
        {
            "tagName": "#bug",
            "postCount": 4
        },
        {
            "tagName": "#autism",
            "postCount": 3
        }
    ]
}
```

**Get Homefeed of a user**

`GET /homefeed`

return list of posts in descending chronological order, based on the requester’s followers and at-mentioned

```
curl -XGET -H 'x-contextual-name: 0xd44a82dD160217d46D754a03C8f841edF06EBE3c' 'https://api.auti.sm/v1/homefeed?limit=1'
```

```
{
    "payload":
    [
        {
            "type": "POST",
            "subtype": "REPOST",
            "messageId": "0x3F425586D68616A113C29c303766DAD444167EE8/83f47485e5bfa00d3b11206433acade0589bf4e2039ed7ccfef91aaa8889de54",
            "hash": "83f47485e5bfa00d3b11206433acade0589bf4e2039ed7ccfef91aaa8889de54",
            "createdAt": "1648007814847",
            "payload":
            {
                "topic": "",
                "title": "",
                "content": "",
                "reference": "0x5d432ce201d2c03234e314d4703559102Ebf365C/900450baa9176d246c9199b680f6516d2c813088b4d94372d6a47a5133d1b94d",
                "attachment": ""
            },
            "meta":
            {
                "replyCount": 0,
                "likeCount": 3,
                "repostCount": 1,
                "liked": "0xd44a82dD160217d46D754a03C8f841edF06EBE3c/8d778ad9d1902a6b2250634ec0ff95e7c145c3f8394236b2f0ae5be74450cf5e",
                "reposted": null,
                "blocked": null,
                "interepProvider": null,
                "interepGroup": null,
                "rootId": "0x5d432ce201d2c03234e314d4703559102Ebf365C/900450baa9176d246c9199b680f6516d2c813088b4d94372d6a47a5133d1b94d",
                "moderation": "THREAD_HIDE_BLOCK",
                "modblockedctx": null,
                "modfollowedctx": null,
                "modmentionedctx": null,
                "modLikedPost": null,
                "modBlockedPost": null,
                "modBlockedUser": null,
                "modFollowerUser": null
            }
        }
    ]
}
```

**Get Notifications of a user**

`GET /:address/notifications`

return list of notifications relevant to `:address`

```
curl -XGET -H 'x-contextual-name: 0xd44a82dD160217d46D754a03C8f841edF06EBE3c' 'https://api.zkitter.com/v1/0xd44a82dD160217d46D754a03C8f841edF06EBE3c/notifications?limit=20&offset=0'
```

```
{
    "payload":
    [
        {
            "message_id": "0xd44a82dD160217d46D754a03C8f841edF06EBE3c/36674ef1f4b6a3c71456a06b36ba5c30d8d37a8b341563522a40a3866cb15c49",
            "type": "LIKE",
            "timestamp": "1668534603794",
            "creator": "0x6ae8EA3D4027DFbfdBC9B2e92F2c3D24997d1faa",
            "sender_pubkey": null
        },
        {
            "message_id": "0xf622d6eC8a21532a62BA2CAFdda571c24D670E5c/fe31962c2acfc2667ec9c7e40d5217990e5514b19efef137226cb6135667a74f",
            "type": "REPLY",
            "timestamp": "1649288251572",
            "creator": "0xf622d6eC8a21532a62BA2CAFdda571c24D670E5c",
            "sender_pubkey": null
        },
        {
            "message_id": "35acc3ce433eb71fe4074475f6b1a7c3f18657140c7912f7cf68339aac63b8b3",
            "type": "REPLY",
            "timestamp": "1647656226942",
            "creator": "",
            "sender_pubkey": null
        },
        {
            "message_id": "0x3F425586D68616A113C29c303766DAD444167EE8/15b338b875a4ef5493e41c5fb4c80b6055fc7a5c4470fd4df826088b109e843b",
            "type": "REPLY",
            "timestamp": "1647656027881",
            "creator": "0x3F425586D68616A113C29c303766DAD444167EE8",
            "sender_pubkey": null
        },
        {
            "message_id": "0xf622d6eC8a21532a62BA2CAFdda571c24D670E5c/2560501202b9fb3c7acb659cad4ccddc0c409f37f7a14f10b0d17ae19fb895ad",
            "type": "REPLY",
            "timestamp": "1647655922998",
            "creator": "0xf622d6eC8a21532a62BA2CAFdda571c24D670E5c",
            "sender_pubkey": null
        },
        {
            "message_id": "0x76De5612eD1F97C1042D56f1Dd3ae803045BC58e/637ca4c43d4774d0cf64f80e327c05f1ed2aa9e8f3d39ef2f8223406bab57161",
            "type": "REPLY",
            "timestamp": "1637697489077",
            "creator": "0x76De5612eD1F97C1042D56f1Dd3ae803045BC58e",
            "sender_pubkey": null
        },
        {
            "message_id": "0xd44a82dD160217d46D754a03C8f841edF06EBE3c/4f783b9e43a2e981c88f2871b733235ac29009c91ef1d545bea111b76ebef4fd",
            "type": "REPLY",
            "timestamp": "1637664976039",
            "creator": "0xd44a82dD160217d46D754a03C8f841edF06EBE3c",
            "sender_pubkey": null
        },
        {
            "message_id": "0xd44a82dD160217d46D754a03C8f841edF06EBE3c/c52a8401ead34a3be74946f816d21712913f0f254764745168272b92c48c280a",
            "type": "REPLY",
            "timestamp": "1637493383569",
            "creator": "0xd44a82dD160217d46D754a03C8f841edF06EBE3c",
            "sender_pubkey": null
        },
        {
            "message_id": "0xd44a82dD160217d46D754a03C8f841edF06EBE3c/197986697ade69cf40d8192a5e477a7049cf6823ef7cce292254330b69013e09",
            "type": "LIKE",
            "timestamp": "1637364544736",
            "creator": "0x76De5612eD1F97C1042D56f1Dd3ae803045BC58e",
            "sender_pubkey": null
        },
        {
            "message_id": "0xd44a82dD160217d46D754a03C8f841edF06EBE3c/1d3bceca9d204ae786a65e6c6a745560ab718d901a7413660ce37f1d72e95c36",
            "type": "REPLY",
            "timestamp": "1637315663019",
            "creator": "0xd44a82dD160217d46D754a03C8f841edF06EBE3c",
            "sender_pubkey": null
        },
        {
            "message_id": "0xd44a82dD160217d46D754a03C8f841edF06EBE3c/197986697ade69cf40d8192a5e477a7049cf6823ef7cce292254330b69013e09",
            "type": "LIKE",
            "timestamp": "1637315641901",
            "creator": "0xd44a82dD160217d46D754a03C8f841edF06EBE3c",
            "sender_pubkey": null
        }
    ]
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.zkitter.com/developers/api.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
